\subsection{Data structures}
\label{subsec:data-structures}

One can find in this section the data structures (buffers) within the control
subsystem of the agent defined in \autoref{sec:agent}.

\begin{table}[H]
\centering
\begin{tabular}{rcp{0.6\linewidth}}
 & & \textbf{System configuration} \\\hline
$\memory[\T{B}{C}]$ & $-$ & Pose of the Camera sensor (K)
    with respect to the robot base (B) reference frame\\
$\memory[t_c]$ & $-$ & Current time elapsed since the execution start in
    milliseconds. It is constantly updated via hardware\\
 & & \textbf{Effectors constant parameters} \\\hline
$\memory[v_{max}]$ & $-$ & Maximum linear speed \\
$\memory[\dot{\theta}_{max}]$ & $-$ & Maximum rotation speed \\
%  & & \textbf{Task configuration parameters} \\\hline
 & & \textbf{Task variables} \\\hline
$\memory[\theta_c]$ & $-$ & Integrated angle rotated \\
$\memory[t_e]$ & $-$ & Milliseconds to elapse since $t_s$ for a certain
    condition to be fulfilled\\
$\memory[\leftidx{^B_{1..V}}{O}{_c}]$ & $-$ & A set of verified
    black spot hypotheses w.r.t. the robot base\\
$\memory[\leftidx{^B_t}{O}{_c}]$ & $-$ & Current target black spot w.r.t. the
    robot base. It might not be contained in
$\memory[\leftidx{^B_{1..V}}{O}{_c}]$ when the robot is too close to it
    during the pick phase\\
\end{tabular}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{rcp{0.6\linewidth}}
 & & \textbf{Output to the drive virtual effector $\ve{D}$} \\
\hline
$\ey{D}[\dot{\theta}_d]$ & $-$ & Desired rotation speed\\
$\ey{D}[v_d]$ & $-$ & Desired linear speed\\
 & & \textbf{Input from the drive virtual effector $\ve{D}$} \\
\hline
$\ey{D}[\dot{\theta}_c]$ & $-$ & Current rotation speed\\
$\ey{D}[v_c]$ & $-$ & Current linear speed\\
\\
\end{tabular}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{rcp{0.6\linewidth}}
 & & \textbf{Output to paint spraying nozzle $\ve{S}$} \\
\hline
$\ey{S}[o_d]$ & $-$ & Desired spraying nozzle aperture. Binary value where
    \texttt{TRUE} corresponds to open. \\
 & & \textbf{Input from paint spraying nozzle $\ve{S}$} \\
\hline
$\ey{S}[o_c]$ & $-$ & Current spraying nozzle aperture. Binary value where
    \texttt{TRUE} corresponds to open. \\
\\
\end{tabular}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{rcp{0.6\linewidth}}
 & & \textbf{Input from the Camera sensor $\vr{C}$} \\
\hline
$\rx{C}[\leftidx{^C_{1..V}}{O}{_c}]$ & $-$ & List of
    verified black spot hypotheses w.r.t. the Camera reference frame. Every object
    $\leftidx{^C_v}{O}{_c}, v=1,...,V$ is a tuple, representing a single
    verified hypothesis, with respect to the Camera frame C.
    \begin{center}
        $\leftidx{^C_v}{O}{_c} = \left(
            \leftidx{_v}{\alpha}, \leftidx{_v}{d}, \leftidx{_v}{i}{_c}\right)$
    \end{center}
    \begin{tabular}{rcp{0.72\linewidth}}
    $\leftidx{_v}{\alpha}$&$-$&Angle at which the camera detects the spot, in
    radians, being 0 aligned with the robot front direction, positive to its
    left and negative to its right\\
    $\leftidx{_v}{d}$&$-$&Distance at which the camera detects the spot, in centimeters\\
    $\leftidx{_v}{i}{_c}$&$-$&Object label or identifier\\
    \end{tabular} \\
\\
\end{tabular}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{rcp{0.6\linewidth}}
 & & \textbf{Input from the external agent} \\
\hline
$\leftidx{^T_x}{c}{_{1,p}}[a]$ & $-$ & Binary value, whether the system is
    active or not. When the external agent issues the \texttt{START} command
    mentioned in \autoref{sec:task}, the $a$ variable will be changed into
    \texttt{TRUE}. Correspondingly, the \texttt{STOP} command changes the
    variable into \texttt{FALSE} \\
\\
\end{tabular}
\end{table}
\clearpage